// dbggen.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "convert.h"
#include <string>
#include <sstream>
#include <windows.h>
#include <iostream>

bool FileExists(std::string& filen)
{
	char c[MAX_PATH];
	strcpy(c, filen.c_str());
	HANDLE h=CreateFile(c, GENERIC_READ, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
	bool ret=true;
	if (h==INVALID_HANDLE_VALUE) ret=false;
	CloseHandle(h);
	return ret;
}

int main(int argc, char* argv[])
{
  bool ok = (argc==2);
  if (argc==3 && argv[2]=="/nomap") ok=true;
  if (!ok) {
	  std::cout << "Syntax: map2dbg [/nomap] file.exe\n"; 
	  return 1;
  }

  std::string exe=argv[1]; if (argc==3) exe=argv[2];
  if (!FileExists(exe) && FileExists(exe+".exe")) exe=exe+".exe";
  if (!FileExists(exe) && FileExists(exe+".dll")) exe=exe+".dll";
  if (!FileExists(exe)) {
	  std::cout<< "File '" << exe << "' not found"; 
	  return 1;
  }
  //
  std::stringstream err; 
  int num=convert(exe,err);
  std::string s;
  err >> s;
  if (s.length()==0) {
	  std::cout << "Converted " << num << " symbols.\n";
		  return 0;
  } else {
	  std::cout << s;
	  return 1;
  }
}

